package ejava.corba.delegation;

// 
import ejava.corba.NamingContextUtility;

// 
import java.io.IOException;
import java.util.prefs.Preferences;

// 
import org.omg.CORBA.ORB;
import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContext;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;

public class ServerRegistrar
{

  public static void main(String[] args)
  {

    Preferences preferences =
      Preferences.userNodeForPackage(
        ejava.corba.NamingContextUtility.class);

    try {
      String name = preferences.get("QUERY_SERVER_NAME", null);

      NamingContextUtility.initializeOrb(args);

      ORB orb = NamingContextUtility.getORB();

      // get reference to rootpoa & activate the POAManager
      POA rootpoa =
        POAHelper.narrow(orb.resolve_initial_references("RootPOA"));

      rootpoa.the_POAManager().activate();

      // createQueryServerImplementation
      QueryServerImplementation queryServerImpl =
        new QueryServerImplementation();
      QueryServerPOATie queryServerTie =
        new QueryServerPOATie(queryServerImpl);

      // get object reference from the servant
      org.omg.CORBA.Object reference =
        rootpoa.servant_to_reference(queryServerTie);
      QueryServer queryServer = QueryServerHelper.narrow(reference);
      NamingContext namingContext =
        NamingContextUtility.getNamingContext();

      // bind the Object Reference in Naming
      NameComponent namingComponent = new NameComponent(name, "");
      NameComponent nameComponent[] = { namingComponent };

      namingContext.rebind(nameComponent, queryServer);
      System.out.println("Waiting for clients:");
      orb.run();
    } catch(IOException ioe) {
      System.out.println(ioe);
      ioe.printStackTrace();
      System.exit(0);
    } catch(Exception e) {
      System.out.println(e);
      e.printStackTrace();
      System.exit(0);
    }
  }
}
