package ejava.corba.regular;

// 
import ejava.corba.NamingContextUtility;

// 
import java.util.prefs.Preferences;

// 
import org.omg.CORBA.ORB;
import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContext;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;

public class Client
{

  public static void main(String[] args)
  {

    Preferences preferences =
      Preferences.userNodeForPackage(
        ejava.corba.NamingContextUtility.class);

    try {
      String name = preferences.get("QUERY_SERVER_NAME", null);
      ORB    orb  = NamingContextUtility.getORB();
      POA rootpoa =
        POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
      NamingContext namingContext =
        NamingContextUtility.getNamingContext();

      // bind the Object Reference in Naming
      NameComponent namingComponent = new NameComponent(name, "");
      NameComponent nameComponent[] = { namingComponent };

      System.out.println("Looking for name :" + name);

      QueryServer queryServer =
        QueryServerHelper.narrow(namingContext.resolve(nameComponent));
      ClientReceiverImplementation clientReceiverImpl =
        new ClientReceiverImplementation();
      org.omg.CORBA.Object reference =
        rootpoa.servant_to_reference(clientReceiverImpl);
      ClientReceiver clientReceiver =
        ClientReceiverHelper.narrow(reference);

      queryServer.register("ClientReceiver", clientReceiver);

      String[] customersNames =
        queryServer.findCustomersWhoOrderedForMoreThan(100.0f);

      for(int i = 0; i < customersNames.length; i++) {
        System.out.println("CustomersNames :" + customersNames[i]);

        namingComponent = new NameComponent(customersNames[i], "");

        NameComponent custNameComponent[] = { namingComponent };
        Customer customer = CustomerHelper.narrow(
                              namingContext.resolve(custNameComponent));

        System.out.println(customer.firstName());
        System.out.println(customer.lastName());
      }

      queryServer.findOrdersWhichAreFrom("VA");
      System.out.println("Waiting to Quit:");
      System.in.read();
    } catch(Exception e) {
      System.out.println(e);
      e.printStackTrace();
      System.exit(0);
    }
  }
}
