package ejava.corba.regular;

// 
import ejava.corba.NamingContextUtility;

// 
import org.omg.CORBA.ORB;
import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContext;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAHelper;

public class CustomerImplementation extends CustomerPOA
{

  private String firstName;
  private String lastName;
  private String address1;
  private String address2;
  private String city;
  private String state;
  private String zip;
  private String phoneNumber;
  private String emailAddress;

  public void bind(String name)
  {

    try {
      NamingContext namingContext =
        NamingContextUtility.getNamingContext();

      // bind the Object Reference in Naming
      NameComponent namingComponent = new NameComponent(name, "");
      NameComponent nameComponent[] = { namingComponent };

      //==
      ORB orb = NamingContextUtility.getORB();

      // get reference to rootpoa & activate the POAManager
      POA rootpoa =
        POAHelper.narrow(orb.resolve_initial_references("RootPOA"));

      rootpoa.the_POAManager().activate();

      //==
      org.omg.CORBA.Object reference =
        rootpoa.servant_to_reference(this);
      Customer customer = CustomerHelper.narrow(reference);

      namingContext.rebind(nameComponent, customer);
    } catch(Exception e) {
      System.err.println("Error:" + e);
      e.printStackTrace();
    }
  }

  public String firstName()
  {
    return firstName;
  }

  public void firstName(String newFirstName)
  {
    firstName = newFirstName;
  }

  public String lastName()
  {
    return lastName;
  }

  public void lastName(String newLastName)
  {
    lastName = newLastName;
  }

  public String address1()
  {
    return address1;
  }

  public void address1(String newAddress1)
  {
    address1 = newAddress1;
  }

  public String address2()
  {
    return address2;
  }

  public void address2(String newAddress2)
  {
    address2 = newAddress2;
  }

  public String city()
  {
    return city;
  }

  public void city(String newCity)
  {
    city = newCity;
  }

  public String state()
  {
    return state;
  }

  public void state(String newState)
  {
    state = newState;
  }

  public String zip()
  {
    return zip;
  }

  public void zip(String newZip)
  {
    zip = newZip;
  }

  public String phoneNumber()
  {
    return phoneNumber;
  }

  public void phoneNumber(String newPhoneNumber)
  {
    phoneNumber = newPhoneNumber;
  }

  public String emailAddress()
  {
    return emailAddress;
  }

  public void emailAddress(String newEmailAddress)
  {
    emailAddress = newEmailAddress;
  }
}
