package ejava.ejb;

import java.sql.Connection;
import javax.naming.NamingException;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.DriverManager;
import javax.naming.InitialContext;
import javax.naming.Context;
import javax.sql.DataSource;
import java.util.Properties;

public class EJBHelper {
  // JNDI Names for Home Objects
  public static String CUSTOMER_HOME = "CustomerHome";
  public static String CREDIT_HOME = "CreditHome";
  public static String TSHIRT_HOME = "TShirtHome";
  public static String ITEM_HOME = "ItemHome";
  public static String ORDER_HOME = "OrderHome";
  public static String ADDRESS_HOME = "AddressHome";
  public static String AUTHENTICATION_HOME = "AuthenticationHome";
  public static String BROWSE_SESSION_HOME = "BrowseHome";
  public static String SHOPPING_CART_HOME = "ShoppingCartHome";
  public static String ORDER_MANAGER_HOME = "OrderManagerHome";
  public static String CUSTOMER_MANAGER_HOME = "CustomerManagerHome";
  public static String CREDIT_MANAGER_HOME = "CreditManagerHome";
  public static String TIMER_HOME = "TimerHome";

  // EJB Reference Names for Home Objects
  public static String BROWSE_SESSION_REFNAME =
    "java:comp/env/ejb/browse";
  public static String TSHIRT_REFNAME = "java:comp/env/ejb/tshirt";
  public static String ITEM_REFNAME = "java:comp/env/ejb/item";
  public static String CREDIT_REFNAME = "java:comp/env/ejb/credit";
  public static String CUSTOMER_REFNAME = "java:comp/env/ejb/customer";
  public static String ORDER_REFNAME = "java:comp/env/ejb/order";
  public static String ADDRESS_REFNAME = "java:comp/env/ejb/address";
  public static String AUTHENTICATION_REFNAME =
    "java:comp/env/ejb/authentication";
  public static String ORDER_MANAGER_REFNAME =
    "java:comp/env/ejb/ordermgr";

  public static String BEESHIRTS_DATA_SOURCE =
    "java:comp/env/jdbc/ejavaPool";

  /** Get database Connnection for BeeShirts.com data source */
  public static Connection getDBConnection()
    throws SQLException, NamingException {

    // Create initial context
    InitialContext initialContext = new InitialContext();

    // Lookup DataSource object
    DataSource dataSource =
      (DataSource) initialContext.lookup(
        EJBHelper.BEESHIRTS_DATA_SOURCE);

    // Request Connection object from pool managed by DataSource
    Connection connection = dataSource.getConnection();

    // Close context
    initialContext.close();
    // Return Connection object
    return connection;
  }

  public static Integer getNextCustomerID()
    throws SQLException, NamingException {
    String sqlString = "SELECT MAX(CUSTOMER_ID)+1 FROM CUSTOMER";
    Connection connection = EJBHelper.getDBConnection();
    Statement statement = connection.createStatement();
    ResultSet rs = statement.executeQuery(sqlString);
    rs.next(); // it should have only one row in results.
    Integer returnValue = new Integer(rs.getInt(1));
    rs.close();
    statement.close();
    connection.close();
    return returnValue;
  }

  public static Integer getNextOrderID()
    throws SQLException, NamingException {
    String sqlString = "SELECT MAX(ORDER_ID)+1 FROM ORDERS";
    Connection connection = EJBHelper.getDBConnection();
    Statement statement = connection.createStatement();
    ResultSet rs = statement.executeQuery(sqlString);
    rs.next(); // it should have only one row in results.
    Integer returnValue = new Integer(rs.getInt(1));
    rs.close();
    statement.close();
    connection.close();
    return returnValue;
  }

  public static Integer getNextItemID()
    throws SQLException, NamingException {
    String sqlString = "SELECT MAX(ITEM_ID)+1 FROM ITEM";

    Connection connection = EJBHelper.getDBConnection();
    Statement statement = connection.createStatement();
    ResultSet rs = statement.executeQuery(sqlString);
    rs.next(); // it should have only one row in results.
    Integer returnValue = new Integer(rs.getInt(1));
    rs.close();
    statement.close();
    connection.close();
    return returnValue;
  }

  public static Integer getNextAuthenticationID()
    throws SQLException, NamingException {
    String sqlString = "SELECT MAX(AUTH_ID)+1 FROM AUTHENTICATION";
    Connection connection = EJBHelper.getDBConnection();
    Statement statement = connection.createStatement();
    ResultSet rs = statement.executeQuery(sqlString);
    rs.next(); // it should have only one row in results.
    Integer returnValue = new Integer(rs.getInt(1));
    rs.close();
    statement.close();
    connection.close();
    return returnValue;
  }
}
