package ejava.ejb.entity.address;

import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.CreateException;

/**
  * AddressEJBean is an EntityBean implementation.
  *
  */
public abstract class AddressEJBean implements EntityBean {
  private EntityContext entityContext;

  /**
   *  empty implementations of EntityBean interface,
   *  not needed by this class.
   */
  public void ejbActivate() {
  }

  public void ejbPassivate() {
  }

  public void ejbRemove() {
  }

  public void ejbLoad() {
  }

  public void ejbStore() {
  }

  /**
   * Sets the EntityContext for the EJBean.
   */
  public void setEntityContext(EntityContext entityContext) {
    this.entityContext = entityContext;
  }

  /**
   * Unsets the EntityContext for the EJBean.
   */
  public void unsetEntityContext() {
    entityContext = null;
  }

  /**
   * Default implementation of ejbPostCreate().
   * Each ejbCreate() method should have a
   * corresponding ejbPostCreate() method.
   *
   * @param orderID            order ID
   * @param addressType        Billing Address or delivery Address
   * @param address_1          address_1 of the order
   * @param address_2          address_2 of the order
   * @param city               city of the order
   * @param state              state of the order
   * @param zipCode            zipCode of the order
   */
  public void ejbPostCreate(Integer orderID, String addressType,
                              String address_1,	String address_2,
                              String city, String state,
                              String zipCode) throws CreateException
    {
  }

  /**
   * This method corresponds to the ejbCreate method in the bean
   * AddressEJBean.java.
   * The parameters of the two methods in both classes are identical.
   * When the client calls this method, the container will generate
   * a call to ejbCreate() on the AddressEJBean.
   *
   * @param orderID            order ID
   * @param addressType        Billing Address or delivery Address
   * @param address_1          address_1 of the order
   * @param address_2          address_2 of the order
   * @param city               city of the order
   * @param state              state of the order
   * @param zipCode            zipCode of the order
   */
  public AddressPrimaryKey ejbCreate(Integer orderID,
                                       String addressType,
                                   String address_1,
                                       String address_2,
                                       String city,
                                       String state,
                                       String zipCode)
                                       throws CreateException
  {
    this.setOrderID(orderID);
    this.setAddressType(addressType);
    this.setAddress_1(address_1);
    this.setAddress_2(address_2);
    this.setCity(city);
    this.setState(state);
    return null;
  }

  public abstract Integer getOrderID();
  public abstract String getAddressType();
  public abstract String getAddress_1();
  public abstract String getAddress_2();
  public abstract String getCity();
  public abstract String getState();
  public abstract String getZipCode();
  public abstract void setOrderID(Integer orderID);
  public abstract void setAddressType(String addressType);
  public abstract void setAddress_1(String address_1);
  public abstract void setAddress_2(String address_2);
  public abstract void setCity(String city);
  public abstract void setState(String state);
  public abstract void setZipCode(String zipCode);
}
