package ejava.ejb.entity.address;

import javax.ejb.EJBLocalHome;
import javax.ejb.CreateException;
import javax.ejb.FinderException;
import java.util.Collection;

/**
 * This is the home interface for the CMRAddressEJBean.
 */
public interface CMRAddressLocalHome extends EJBLocalHome
{
  /**
   * This method corresponds to the ejbCreate method in the bean
   * AddressEJBean.java.
   * The parameters of the two methods in both classes are identical.
   * When the client calls this method, the container will generate
   * a call to ejbCreate() on the AddressEJBean.
   *
   *
   * @param orderID            order ID
   * @param addressType        Billing Address or delivery Address
   * @param address_1          address_1 of the order
   * @param address_2          address_2 of the order
   * @param city               city of the order
   * @param state              state of the order
   * @param zipCode            zipCode of the order
   */
  public CMRAddressLocal create(Integer orderID, String addressType,
                                String address_1, String address_2,
                                String city, String state,
                                String zipCode)
                              throws CreateException;

  /**
   * Finds the Address object in the database given its
   * Primary Key.
   *
   * @param addressKey   Primary Key
   * @return             AddressLocal
   */
  public CMRAddressLocal findByPrimaryKey(AddressPrimaryKey addressKey)
      throws FinderException;

}

