package ejava.ejb.entity.credit;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.util.Hashtable;
import javax.rmi.PortableRemoteObject;

import java.util.Enumeration;
import java.util.Vector;
import java.rmi.RemoteException;
import javax.ejb.CreateException;
import java.util.Collection;
import java.util.Iterator;
import java.sql.Date;
import java.text.SimpleDateFormat;

public class TestClient
{
  private static String userName;
  private static String password;
  private static int searchCustomerID =101;
  private static int searchOrderID = 1001;
  private static String searchCardNumber = "12344905656";


  /**
   * Create new Credit information
   */
  public static void createNewCreditInfo(CreditHome creditHome)
    throws RemoteException, CreateException
  {
    int customerID = searchCustomerID;
    int orderID =   searchOrderID;
    String cardNumber = searchCardNumber;
    String cardType = "CREDIT";
    String cardName = "VISA";
    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
    Date expirationDate = null;
    try
    {
       expirationDate= new Date(dateFormat.parse("2004-02-24").getTime());
    } catch (Exception e) {}

    String cardConfirmation = "0909090909090";
    Hashtable creditInfo = new Hashtable();
    creditInfo.put(CreditDefinition.CUSTOMER_ID ,
      new Integer(searchCustomerID) );
    creditInfo.put(CreditDefinition.ORDER_ID ,
      new Integer(searchOrderID) );
    creditInfo.put(CreditDefinition.CARD_NUMBER ,
      searchCardNumber );
    creditInfo.put(CreditDefinition.CARD_NUMBER_FK ,
      searchCardNumber );
    creditInfo.put(CreditDefinition.CARD_TYPE,
      cardType);
    creditInfo.put(CreditDefinition.CARD_NAME ,
      cardName );
    creditInfo.put(CreditDefinition.EXPIRE_DATE,
      expirationDate );
    creditInfo.put(CreditDefinition.CARD_CONFIRMATION_NUMBER,
      cardConfirmation );
    creditHome.create(creditInfo);

  }

  public static void main(String[] args)
  {
    try{
      System.out.println("Getting Context :" );
      Context context = new InitialContext();
      Object objectRef =
          context.lookup("CreditHome");

      CreditHome  creditHome =
        (CreditHome)PortableRemoteObject.narrow(objectRef,
            ejava.ejb.entity.credit.CreditHome.class);
        // Create new Credit for a customer
        createNewCreditInfo(creditHome);
        // query credit info for the primary key
        CreditPrimaryKey creditPrimaryKey = new CreditPrimaryKey();
        creditPrimaryKey.cardNumber = searchCardNumber;
        creditPrimaryKey.customerID = searchCustomerID;
        creditPrimaryKey.orderID =  searchOrderID;
        Credit credit = creditHome.findByPrimaryKey(creditPrimaryKey);
        System.out.println(" Received Credit :" + credit);
        Hashtable creditInfo = credit.getCreditInformation();
        System.out.println("Received Credit Info :"+creditInfo);

        System.out.println("Querying by CustomerID  and Order ID :");
        // query credit info for a given customer and order
        Collection credits =
              creditHome.findByCustomerIDAndOrderID(searchCustomerID,
                                                    searchOrderID);
        Iterator creditsIterator = credits.iterator();
        while(creditsIterator.hasNext()){
          Credit creditInfoValue = (Credit)creditsIterator.next();
          System.out.println(creditInfoValue.getClass());
          creditInfo = creditInfoValue.getCreditInformation();
          System.out.println(" Received Credit Info:" + creditInfo);
        }
        System.out.println("Querying by customerID :");
        // query credit info for a customerID
        credits = creditHome.findByCustomerID(searchCustomerID);
        creditsIterator = credits.iterator();

        while(creditsIterator.hasNext()){
          Credit creditInfoValue = (Credit)creditsIterator.next();
          System.out.println(creditInfoValue.getClass());
          creditInfo = creditInfoValue.getCreditInformation();
          System.out.println(" Received Credit Info:" + creditInfo);
        }

    }
    catch(Exception exception){
      exception.printStackTrace();
    }
  }
}
