package ejava.ejb.entity.customer;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.util.Hashtable;
import javax.rmi.PortableRemoteObject;

import java.util.Collection;
import java.util.Vector;
import java.rmi.RemoteException;
import javax.ejb.CreateException;

public class TestClient
{
  private static String userName;
  private static String password;
  private static int searchCustomerID = 102;
  private static String  searchEmail = "rv@rvictor.com";

  private static void printCustomerInformation(Customer customer)
    throws RemoteException
  {
    System.out.println(" Customer FirstName :" +
      customer.getFirstName());
    System.out.println("Last Name :" + customer.getLastName());
    System.out.println("Middle Name :"+customer.getMiddleName());
    System.out.println("EMAIL : "+customer.getEmail());
    System.out.println("Address 1 :" + customer.getAddress_1());
    System.out.println("Address 2 :" + customer.getAddress_2());
    System.out.println("City :" + customer.getCity());
    System.out.println("State :" + customer.getState());
    System.out.println(" Zip Code :" + customer.getZipCode());
    System.out.println(" Phone :" + customer.getPhone());
    System.out.println(" id :" + customer.getCustomerID());
  }

  public static void createNewCustomer(CustomerHome customerHome)
    throws RemoteException , CreateException
  {
    Integer id = new Integer(500);
    String firstName = "John";
    String lastName = "Melson";
    String middleName ="";
    String email = "jm@jmelson.com";
    String address_1="JM St.";
    String address_2="123";
    String city = "Pasadena";
    String state = "CA";
    String zipCode ="12345";
    String phone = "000000000";
    customerHome.create( id,firstName,  lastName,
     middleName,  email,  address_1, address_2, city,
     state,  zipCode,   phone);

  }

  public static void main(String[] args)
  {
    try{
      System.out.println("Getting Context :" );
      Context context = new InitialContext();
      Object objectRef =
          context.lookup("CustomerHome");
      System.out.println(objectRef);
      CustomerHome customerHome =
        (CustomerHome)PortableRemoteObject.narrow(objectRef,
          ejava.ejb.entity.customer.CustomerHome.class);

      Customer customer = customerHome.findByPrimaryKey(
        new Integer(searchCustomerID));
      System.out.println(" Received customer Find By PrimaryKey: " +
         customer);
      printCustomerInformation( customer);
      customer = customerHome.findByEmail(searchEmail);
      printCustomerInformation( customer);
      createNewCustomer( customerHome);

    }
    catch(Exception exception){
      exception.printStackTrace();
    }
  }
}
