package ejava.ejb.entity.item;

import javax.ejb.EJBLocalHome;
import javax.ejb.CreateException;
import javax.ejb.FinderException;
import java.util.Collection;

public interface CMRItemLocalHome extends EJBLocalHome
{

  /**
   * This method corresponds to the ejbCreate method in the bean
   * ItemEJBean.java.
   *
   * @param itemID         Item ID
   * @param quantity       quantity of Item
   * @param totalPrice     total price of Item
   *
   * @return               Item
   */
  public CMRItemLocal create(Integer itemID, Integer quantity,
                             double totalPrice) throws CreateException;

  /**
   * Finds an Item given its primary key
   *
   * @param itemID         item ID
   * @return               Item
   */
  public CMRItemLocal findByPrimaryKey(Integer itemID)
    throws FinderException;

 /**
  * Finds a Collection of Items associated with an order ID
  *
  * @param orderID         ID of the Order
  * @return                A Collection of items
  */
  public Collection findByOrderID(Integer orderID)
    throws FinderException;
}

