package ejava.ejb.entity.item;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.util.Hashtable;
import javax.rmi.PortableRemoteObject;

import java.util.Collection;
import java.util.Iterator;
import java.rmi.RemoteException;
import javax.ejb.CreateException;

public class TestClient
{
  private static String userName;
  private static String password;
  private static int searchItemID = 10;
  private static int searchOrderID = 1001;

  public static void printItem(Item item)
    throws RemoteException
  {
    System.out.println(" Received item :" + item);
    System.out.println("Quantity :" +item.getQuantity());
    System.out.println("Total Price :" + item.getTotalPrice());
  }

  public static void createAnItem(ItemHome itemHome)
    throws CreateException, RemoteException
  {
     int nextItemID = 701;
     int quantity = 30;
     int orderID = 1001;
     double totalPrice = 600.79;
     ejava.ejb.entity.item.Item item
          = itemHome.create(new Integer(nextItemID), new Integer(quantity),
              totalPrice, new Integer(orderID));
     System.out.println("Created :"+item);

  }

  public static void main(String[] args)
  {
    try{
      System.out.println("Getting Context :" );
      Context context = new InitialContext();
      Object objectRef =
          context.lookup("ItemHome");
      ItemHome itemHome =
        (ItemHome)PortableRemoteObject.narrow(objectRef,
          ejava.ejb.entity.item.ItemHome.class);

      Item item = itemHome.findByPrimaryKey(
        new Integer(searchItemID));
      printItem(item);
      Collection items = itemHome.findByOrderID(
        new Integer(searchOrderID));
     Iterator iterator = items.iterator();
      while(iterator.hasNext()){
        Item itemn = (Item)iterator.next();
        printItem(itemn);
         }
      createAnItem( itemHome);


    }
    catch(Exception exception){
      exception.printStackTrace();
    }
  }
}

