package ejava.ejb.entity.order;

import javax.ejb.EJBLocalObject;
import java.sql.Date;
import java.util.Collection;
import ejava.ejb.entity.customer.CMRCustomerLocal;
import ejava.ejb.entity.address.CMRAddressLocal;

/**
 * The methods in this interface are the relationship
 * getters/setters that the client calls for this Bean.
 */
public interface CMROrderLocal extends OrderLocal {
	/**
	 * Local relationship accessors for one to many
	 * relationship between an Order and Item.
	 */
	public Collection getItems();
	public void setItems(Collection items);

	/**
	 * Local relationship accessors for many to one
	 * relationship between an Order and Customer.
	 */
	public CMRCustomerLocal getCustomer();
	public void setCustomer(CMRCustomerLocal customer);

	/**
	 * Local relationship accessors for one to many
	 * relationship between an Order and Address.
	 */
	public Collection getAddresses();
	public void setAddresses(Collection addresses);
}
