package ejava.ejb.entity.order;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.util.Hashtable;
import javax.rmi.PortableRemoteObject;

import java.util.Collection;
import java.util.Iterator;
import java.rmi.RemoteException;
import javax.ejb.CreateException;
import java.sql.Date;


public class TestClient
{
  private static int searchOrderID = 1002;
  private static int searchCustomerID = 101;

  public static void printOrder(Order order)
    throws RemoteException
  {
    System.out.println("Received Order :" + order);
    System.out.println("Ship Charge :" +order.getShipCharge());
    System.out.println("Paid Date :" +order.getPaidDate());
    System.out.println("Ship Date :" + order.getShipDate());
    System.out.println("Ship Instructions :" +
                       order.getShippingInstructions());
    System.out.println("Ship Weight :" + order.getShipWeight());
    System.out.println("CustomerID :" + order.getCustomerID());
  }

  public static void createNewOrder(OrderHome orderHome)
    throws RemoteException, CreateException
  {
    Integer orderID = new Integer(2000);
    Integer customerID = new Integer(101);
    Date orderDate = new Date(System.currentTimeMillis());
    String shippingInstruct = "Leave at Door";
    Date defaultShipDate = new Date(System.currentTimeMillis());
    double shipWeight = 8.0;
    double shipCharge = 8.56;
    Date paidDate = new Date(System.currentTimeMillis());

    orderHome.create(orderID, customerID, orderDate, shippingInstruct,
      defaultShipDate, shipWeight, shipCharge, paidDate);

  }

  public static void main(String[] args)
  {
    try{
      System.out.println("Getting Context :" );
      Context context = new InitialContext();
      Object objectRef =
          context.lookup("OrderHome");
      OrderHome orderHome =
        (OrderHome)PortableRemoteObject.narrow(objectRef,
          ejava.ejb.entity.order.OrderHome.class);

      Order order = orderHome.findByPrimaryKey(
        new Integer(searchOrderID));
      printOrder(order);
      Collection orders = orderHome.findByCustomerID(
        new Integer(searchCustomerID));
     Iterator iterator = orders.iterator();
     while(iterator.hasNext()){
        Order ordern = (Order)iterator.next();
        printOrder(ordern);
      }
         createNewOrder(orderHome);
    }
    catch(Exception exception){
      exception.printStackTrace();
    }
  }
}
