package ejava.ejb.security.jaas;

import javax.security.auth.Subject;
import javax.security.auth.callback.TextInputCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.login.LoginContext;
import javax.security.auth.login.LoginException;
import javax.security.auth.login.FailedLoginException;
import javax.security.auth.login.AccountExpiredException;
import javax.security.auth.login.CredentialExpiredException;
import javax.security.auth.Subject;

public class TestClient {

	/**
 	 * Attempt to authenticate the user.
	 */
	public static void main(String[] args) {
		String username = null;
		String password = null;
		LoginContext loginContext = null;

		try {
			// Create Login Context using example callback handler
			loginContext =
				new LoginContext("Test", new TestCallbackHandler());

			// Login attempt, if return without an exception...success!
			loginContext.login();

      // Get the authenticated subject from the login context
      Subject subject = loginContext.getSubject();
      
      // Try to do a security-critical action
      TestAction testAction = new TestAction();
      Subject.doAsPrivileged(subject, testAction, null);

      System.exit(0);
		} catch (SecurityException se) {
			se.printStackTrace();
			System.exit(-1);
		} catch (FailedLoginException fle) {
			System.out.println("Failed to Authenticate, " + fle.getMessage());
			System.exit(-1);
		} catch (AccountExpiredException aee) {
			System.out.println("Failed to Authenticate: Account Expired");
			System.exit(-1);
		} catch (CredentialExpiredException cee) {
			System.out.println("Failed to Authenticate: Credentials Expired");
			System.exit(-1);
		} catch (Exception e) {
			System.out.println(
				"Failed to Authenticate: Unexpected Exception,"
					+ e.getMessage());
			e.printStackTrace();
			System.exit(-1);
		}
	}
}
