package ejava.ejb.session.creditmgr;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.util.Date;
import java.util.Hashtable;
import javax.rmi.PortableRemoteObject;
import javax.ejb.CreateException;

import java.util.Enumeration;
import java.util.Vector;
import java.rmi.RemoteException;

import ejava.ejb.EJBHelper;
import ejava.ejb.entity.credit.CreditDefinition;
import ejava.ejb.entity.credit.CreditLocal;
import ejava.ejb.entity.credit.CreditLocalHome;

public class CreditManagerHandler
{
  public static void handleNewCredit(int customerID, String cardType,
                                     String cardName,
                                     String cardNumber,
                                     Date expirationDate,
                                     String defaultConfirmationNumber)
  {

    try{
      // get Initial Context
      System.out.println("Getting Credit Home :");
      CreditLocalHome creditHome = lookupCreditHome();
      System.out.println("Got Credit Home :");
      Hashtable creditInfo = new Hashtable();
      creditInfo.put(CreditDefinition.CUSTOMER_ID,
          new Integer(customerID));
      int defaultOrderID = 1001;
      creditInfo.put(CreditDefinition.ORDER_ID,
          new Integer(defaultOrderID));
      creditInfo.put(CreditDefinition.CARD_NUMBER,
          cardNumber );
      creditInfo.put(CreditDefinition.CARD_NUMBER_FK ,
          cardNumber );
      creditInfo.put(CreditDefinition.CARD_TYPE,
          cardType) ;
      creditInfo.put(CreditDefinition.EXPIRE_DATE,
          new java.sql.Date(expirationDate.getTime())) ;
      creditInfo.put(CreditDefinition.CARD_CONFIRMATION_NUMBER,
          defaultConfirmationNumber) ;
      creditInfo.put(CreditDefinition.CARD_NAME,
          cardName) ;
      System.out.println("Creating Credit :");
      CreditLocal credit = creditHome.create(creditInfo);
      System.out.println("Created Credit :"+credit);


    }catch(NamingException namingException){
      namingException.printStackTrace();
    }
    catch(CreateException createException){
      createException.printStackTrace();
    }
  }

  /**
   * Gets an initial context used for J2EE environment
   */
   private static CreditLocalHome  lookupCreditHome( )
    throws NamingException
  {
    Context  context =  new InitialContext();
    Object objectRef =
          context.lookup(EJBHelper.CREDIT_REFNAME);
    CreditLocalHome  creditHome =
        (CreditLocalHome)PortableRemoteObject.narrow(objectRef,
            ejava.ejb.entity.credit.CreditLocalHome.class);

    return creditHome;
  }
}

