package ejava.ejb.session.shoppingcart;

import javax.ejb.EJBLocalObject;
import java.util.Vector;
import ejava.servlets.Order;

public interface ShoppingCartLocal  extends EJBLocalObject
{
  /**
   * Add an item to this shopping session with an ID and quantity
   */
  public void addAnItemToTheCart(int shirtID, int quantity);

  /**
   * Obtain a Vector of Serializable TShirt objects for the
   * items stored in this shopping session
   */
  public Vector getSelectedItemsInTheCart();

  /**
   * Check out of this shopping session by creating and returning
   * an order for the items associated with this shopping session.
   * Input order contains order information.
   * Return order contains order w/assigned order ID.
   */
  public Order checkOut(Order order);

  /**
   *  Check out of this shopping session by creating and returning
   *  an order for the items associated with this shopping session.
   *  Input customer ID associated with order for address
   *  information lookup. Other default shipping information is used.
   *  Return order contains order w/assigned order ID.
   */
  public Order checkOut(int customerID);
}
