package ejava.ejb.webservices;

import javax.xml.rpc.Stub;
import javax.naming.NamingException;
import javax.naming.InitialContext;
import java.util.prefs.Preferences;
import java.util.Enumeration;

import ejava.webservices.rpc.*;

public class QueryJ2EEAppClient
{
   public static void main(String[] args){
    try{
      // Logical service reference JNDI name
      String serviceNameContext =
      	"java:comp/env/service/QueryService";

      // Use JNDI to lookup QueryService handle
      //  -- Note that QueryService is a generated interface
      InitialContext ic = new InitialContext();
      QueryService queryService =
        (QueryService)ic.lookup(serviceNameContext);

      // Use the QueryService to get a QueryServer handle
      QueryServer  queryServerPort =
          queryService.getQueryServerPort();

      // Invoke the QueryServer's ping() method
      System.out.println("<QueryServer.ping() via AppClient>:\n" +
      queryServerPort.ping() + "\n");

      // Invoke the QueryServer's findOrder() method
      int orderID = 1002;
      System.out.println("<QueryServer.findOrder() via AppClient>:\n"
    	          + queryServerPort.findOrder(orderID) + "\n");
    }catch(Exception e){
      e.printStackTrace();
    }
  }
}

