package ejava.jaxp;

import org.xml.sax.EntityResolver;
import org.xml.sax.SAXException;
import org.xml.sax.InputSource;
import org.xml.sax.SAXParseException;

import java.io.IOException;
import java.net.URL;
import java.io.InputStream;

/**
  * Implements EntityResolver. If it sees a specific
  * systemID, it creates a different InputSource to
  * read data.
  */

public class SampleEntityResolver implements EntityResolver
{

  /**
  * to resolve each entity, resolveEntity is called by parser
  */
  public InputSource resolveEntity(String publicID,
                                 String systemID)
    throws SAXException, IOException
  {
    System.out.println("Entity Resolver Public ID :" + publicID);
    System.out.println("Entity Resolver System ID :" + systemID);

	// Modify this value to induce reading from another input source
    String urlString =
      "http://localhost/examples/src/ejava/jaxp/dtdAndXmlDocument.xml";

    if (systemID.equals(urlString)) {
       // return a new input source
       URL url = new URL(urlString);
       InputStream inputStream = url.openStream();
       return new InputSource(inputStream);
     } else {
       // return null and require us of default systemID
       return null;
     }
  }
}
