package ejava.jaxp;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/**
  * implements Error Handler
  */

public class SampleErrorHandler implements ErrorHandler
{

  /**
  * it receives the errors of type recoverable Errors
  */
  public void error(SAXParseException saxParseException)
    throws SAXException
  {
  	System.out.println("ERROR ...");
    printException(saxParseException);
  }

  /**
  * to receive the Fatal or non recoverable Error
  */
  public void fatalError(SAXParseException saxParseException)
    throws SAXException
  {
  	System.out.println("FATAL ERROR ...");  	
    printException(saxParseException);
  }

  /**
  * to receive warnings from the parser
  */
  public void warning(SAXParseException saxParseException)
    throws SAXException
  {
  	System.out.println("WARNING ...");  	
    printException(saxParseException);
  }

  private void printException(SAXParseException saxParseException)
  {
    System.out.println(saxParseException);
    System.out.println("Error Handler Column # :"
                       	+ saxParseException.getColumnNumber());
    System.out.println("Error Handler Line # : " 
    					+ saxParseException.getLineNumber());
    System.out.println("Error Handler System ID :"
    					+ saxParseException.getSystemId());
    System.out.println("Error Handler Public ID :"
    					+saxParseException.getPublicId());
  }
}
