
package ejava.jdbc.advanced;

import java.sql.Date;
import java.sql.SQLData;
import java.sql.SQLInput;
import java.sql.SQLOutput;
import java.sql.SQLException;

/**
 * This class implements the SQLType for CHARGE_CARD_TYPE in SQL
 * CREATE TYPE CARD_TYPE AS OBJECT
 * (
 * CARD_TYPE        CHAR(5)   ,
 * CARD_NAME        VARCHAR(20) ,
 * CARD_NUMBER      CHAR(16)  ,
 * EXPIRE_DATE      DATE   ,
 * CARD_CONFIRMATION_NUMBER VARCHAR(20)
 * )
 */
public class ChargeCard implements SQLData
{
  public String cardType;
  public String cardName;
  public String cardNumber;
  public Date expireDate;
  public String cardConfirmationNumber;
  public String sqlType;
  
  /**
   * Constructor
   *
   *
   * @see
   */
  public ChargeCard() {}
  
  /**
   * Constructor
   *
   *
   * @param sqlType
   * @param cardType
   * @param cardName
   * @param cardNumber
   * @param expireDate
   * @param cardConfirmationNumber
   *
   * @see
   */
  public ChargeCard(String sqlType, String cardType, String cardName,
                    String cardNumber, Date expireDate,
                    String cardConfirmationNumber)
  {
    this.cardType = cardType;
    this.cardName = cardName;
    this.cardNumber = cardNumber;
    this.expireDate = expireDate;
    this.cardConfirmationNumber = cardConfirmationNumber;
    this.sqlType = sqlType;
  }
  
  /**
   * Method
   *
   *
   * @return
   *
   * @see
   */
  public String getSQLTypeName()
  {
    return sqlType;
  }
  
  /**
   * Method
   *
   *
   * @param stream
   * @param type
   *
   * @throws SQLException
   *
   * @see
   */
  public void readSQL(SQLInput stream, String type)
    throws SQLException
  {
    cardType = stream.readString();
    cardName = stream.readString();
    cardNumber = stream.readString();
    expireDate = stream.readDate();
    cardConfirmationNumber = stream.readString();
    sqlType = type;
  }
  
  /**
   * Method
   *
   *
   * @param stream
   *
   * @throws SQLException
   *
   * @see
   */
  public void writeSQL(SQLOutput stream)
    throws SQLException
  {
    stream.writeString(cardType);
    stream.writeString(cardName);
    stream.writeString(cardNumber);
    stream.writeDate(expireDate);
    stream.writeString(cardConfirmationNumber);
  }
  
  /**
   * Method
   *
   *
   * @return
   *
   * @see
   */
  public String toString()
  {
    String rString = " ChargeCard Type contents = { "
      + "cardType :" + cardType + "cardName :" + cardName
      + "cardNumber" + cardNumber + "expireDate :"
      + expireDate + "cardConfirmationNumber :"
      + cardConfirmationNumber + " }";
    
    return rString;
  }
  
}

