package ejava.jndi.directory;
import javax.naming.event.NamespaceChangeListener;
import javax.naming.event.ObjectChangeListener;
import javax.naming.event.NamingEvent;
import javax.naming.event.NamingExceptionEvent;
import javax.naming.NamingException;
/**
  * This implements the Namespace listener. it just
  * displays the events it receives.
  */
public class SampleNamingListener  implements NamespaceChangeListener,
  ObjectChangeListener
{
/**
  * If an object is added to the source, object added is called
  */
  public void objectAdded(NamingEvent namingEvent)
  {
    System.out.println(" Object Added :");
    System.out.println("Change information :"+ namingEvent.getChangeInfo());
    System.out.println("New binding :"+ namingEvent.getNewBinding());
  }
/**
  * If an object is removed from a source, object removed is called.
  */
  public void objectRemoved(NamingEvent namingEvent)
  {
    System.out.println(" Object Removed :");
    System.out.println("Old binding :"+ namingEvent.getOldBinding());
  }
/**
  * if Object name is renamed in the source, object renamed is called.
  */
  public void objectRenamed(NamingEvent namingEvent)
  {
    System.out.println(" Object Renamed :");
    System.out.println("Old binding :"+ namingEvent.getOldBinding());
    System.out.println("New binding :"+ namingEvent.getNewBinding());
  }
/**
  * if an object is changed in the soruce object changed is called.
  */
  public void objectChanged(NamingEvent namingEvent)
  {
    System.out.println(" Object Changed :");
    System.out.println("Change information :"+namingEvent.getChangeInfo());
    System.out.println("Old binding :"+ namingEvent.getOldBinding());
    System.out.println("New binding :"+ namingEvent.getNewBinding());

  }
/**
  * if there is exception in the source, namingExceptionThrown is called.
  */
  public void namingExceptionThrown(NamingExceptionEvent namingExceptionEvent)
  {
   System.out.println(" NamingException Event :");
   NamingException namingException =namingExceptionEvent.getException();
   System.out.println(" Exception :"+ namingException);
  }

}
