package ejava.jndi.directory.tradingexample;
import org.omg.CORBA.TCKind.*;
import org.omg.CORBA.*;
import org.omg.CosTrading.*;
import org.omg.CosTrading.*;
import org.omg.CosTradingRepos.*;
import org.omg.CosTradingRepos.ServiceTypeRepositoryPackage.*;
import org.omg.CosTrading.LookupPackage.*;
/**
  * implements the client to Trading Service
  * and add shows how to query for customer object
  * in the trading service.
  */
public class CustomerTradingClient
{


  /**
    * list all the service types in the repository
    */
  public static void listAllServiceTypes(ServiceTypeRepository
    serviceTypeRepository, Lookup lookup)
  {
    SpecifiedServiceTypes specifiedTypes = new SpecifiedServiceTypes();
    specifiedTypes.__default(ListOption.all);
    String[] serviceTypes = serviceTypeRepository.list_types(specifiedTypes);
    System.out.println(" Available Types : Begin");
    for(int i = 0; i< serviceTypes.length; i++){
      System.out.println(serviceTypes[i]);
    }
    System.out.println(" Available Types : End");
  }
  /**
    * remove a Service from the repository
    */
  public static void removeAServiceType(String typeName,
    ServiceTypeRepository serviceTypeRepository)
  {
   try{
    serviceTypeRepository.remove_type(typeName);
   }
   catch(HasSubTypes hasSubTypes){
    System.out.println("It has StubType :"+hasSubTypes);
    hasSubTypes.printStackTrace();
   }
   catch(UnknownServiceType unknownServiceType){
    System.out.println("UnknownServicetype :"+unknownServiceType);
    unknownServiceType.printStackTrace();
   }
   catch(IllegalServiceType illegalServiceType){
    System.out.println("UnknownServicetype :"+illegalServiceType);
    illegalServiceType.printStackTrace();
   }
  }
  /**
    * describe a Type
    */
  public static void describeAType(String typeName,
    ServiceTypeRepository serviceTypeRepository)
  {
    try{
      TypeStruct typeStruct = serviceTypeRepository.describe_type(typeName);
      System.out.println("Description of Type :"+typeName+" is :");
      System.out.println(" if name :"+typeStruct.if_name);
      System.out.println(" super type names :"+typeStruct.super_types);
      System.out.println(" is masked :"+typeStruct.masked);
      System.out.println(" incarnation value :"+typeStruct.incarnation);
      for(int i = 0; i<typeStruct.props.length; i++){
        System.out.println(" Property Name :" +typeStruct.props[i].name);
        System.out.println(" Property Value Type :" +
          typeStruct.props[i].value_type);
      }
    }
    catch(UnknownServiceType unknownServiceType){
      System.out.println("UnknownServicetype :"+unknownServiceType);
      unknownServiceType.printStackTrace();
    }
    catch(IllegalServiceType illegalServiceType){
      System.out.println("UnknownServicetype :"+illegalServiceType);
      illegalServiceType.printStackTrace();
    }
  }

  public static void  queryAndDisplayCustomers(String serviceTypeName,
    int customer_id, Lookup lookup)
  {
    String constraint = "customer_id >" + customer_id ;
    String preferences = "";
    org.omg.CosTrading.Policy [] policies = new  org.omg.CosTrading.Policy [0];
    SpecifiedProps specifiedProperties = new SpecifiedProps();
    specifiedProperties.__default(HowManyProps.all);

    int howMany = 10;
    //  OfferIteratorHolder,OfferSeqHolder, PolicyNameSeqHolder are
    // return values  from the query.
    OfferIteratorHolder offerIterator = new OfferIteratorHolder();
    OfferSeqHolder offerList = new OfferSeqHolder();
    PolicyNameSeqHolder limits = new PolicyNameSeqHolder();
    try
    {
        lookup.query (serviceTypeName, constraint, preferences, policies,
               specifiedProperties, howMany, offerList, offerIterator, limits);
    }
    catch (Exception exception)
    {
        System.err.println ("Problem Getting from Trader: " + exception);
      exception.printStackTrace();
    }
    Offer offer = null;
    if (offerList.value.length > 0)
    {

      for(int i=0; i< offerList.value.length; i++){
        offer = offerList.value [i];
        System.out.println (offer);
          System.out.println (offer.reference);
          Customer  customer = CustomerHelper.narrow (offer.reference);
          System.out.println ("Result Customer ");
          System.out.println(" First Name : " +customer.first_name());
        System.out.println(" Last Name : " +customer.last_name());
        System.out.println(" Street  : " +customer.street());
        System.out.println(" City :" +customer.city());
        System.out.println(" State : " +  customer.state());
        System.out.println("Zip :" +customer.zip());
        System.out.println("Email :" + customer.email());
     }
          System.out.println ("Cusomter Query  ended");
    }

  }


  public static void main(String[] args)
  {

      try{
        // initialize orb and get instance of it.
        org.omg.CORBA.ORB orb
         = org.omg.CORBA.ORB.init (args, null);
        // get the TradingService Object
        org.omg.CORBA.Object tradingServiceReference
          = orb.resolve_initial_references("TradingService");
        Lookup lookup = LookupHelper.narrow(tradingServiceReference);
        Register register = lookup.register_if();
        String interfaceType =  "IDL:ejava/jndi/directory/tradingexample/Customer:1.0";
        String serviceType =   "CustomerObjectsService";
        ServiceTypeRepository serviceTypeRepository;
          serviceTypeRepository =
            ServiceTypeRepositoryHelper.narrow(lookup.type_repos());
       // list all available Services in the TradingService
       listAllServiceTypes(serviceTypeRepository, lookup);
       // remove a service from the Trading Service
       describeAType(serviceType, serviceTypeRepository);
       // query and display  Customer whose id > 123
       queryAndDisplayCustomers(serviceType,123,lookup);

       // remove the type from the Repository
       removeAServiceType(serviceType, serviceTypeRepository);

      }
      catch(Exception exception)
      {
       System.out.println("Error :"+exception);
       exception.printStackTrace();
       System.exit(0);
      }
  }
}