package ejava.jsp.tagext;

import java.io.InputStream;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;

import javax.servlet.jsp.tagext.PageData;
import javax.servlet.jsp.tagext.TagLibraryValidator;
import javax.servlet.jsp.tagext.ValidationMessage;

public class BasicTagLibraryValidator extends TagLibraryValidator
{

    public BasicTagLibraryValidator()
    {
    }

    public ValidationMessage[] validate(String prefix,
                                        String uri,
                                        PageData page)
    {
        // simple validation checks prefix declared in taglib
        // directive, searches content of page to see if it
        // is used on page anywhere.  Returns error message if
        // taglib declared but no tags used on the page.
        InputStream is = page.getInputStream();
        InputStreamReader isr = new InputStreamReader(is);
        BufferedReader br = new BufferedReader(isr);
        StringBuffer buf = new StringBuffer();
        String line = null;

        try
        {
            line  = br.readLine();
            while (line != null)
            {
                buf.append(line);
                line = br.readLine();
            }

            System.out.println("validating tag lib");

            String pageString = buf.toString();
            // now find an actual tag reference on the page
            if (pageString.indexOf("<" + prefix + ":") == -1)
            {
                ValidationMessage[] msgs = new ValidationMessage[1];
                String errMsg = "No tags from the " +  prefix + 
                    "library are used on this page.";

                msgs[0] = new ValidationMessage(null, errMsg);
                return msgs;
            }
            else
            {
                return null;
            }
        }
        catch (Exception e)
        {
            // handle exception here
        }

        return null;
    }
}
