package ejava.rmi;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Vector;

/**
 * Interface
 * This is the interface for OrderManager
 *
 */
public interface QueryServer extends Remote
{

  /**
   * This method finds the customers who spend more than
   * the given value and binds them to the registry and
   * returns the bound customer ids to the client in a Vector.
   */
  public Vector findCustomersWhoOrderedForMoreThan(float value)
          throws RemoteException;

  /**
   * This method finds the orders from a given state,
   * and passes the result Order obects to the registered ClientReceiver
   */
  public void findOrdersWhichAreFrom(String state)
          throws RemoteException;

  /**
   * Client registers the ClientReceiver instance with the
   * OrderManager. OrderManager passes the Orders
   * this instance.
   */
  public void register(String name, ClientReceiver clientReceiver)
          throws RemoteException;
}

