package ejava.rmi.queryserviceiiop;

import java.rmi.RemoteException;
import javax.rmi.PortableRemoteObject;
import javax.naming.InitialContext;
import org.omg.CosNaming.NamingContextHelper;
import org.omg.CosNaming.NamingContext;
import org.omg.CosNaming.NameComponent;
import ejava.rmi.Customer;

/**
 * Customer interface implementation class
 */
public class CustomerImplementation extends PortableRemoteObject
  implements Customer
{
  private String firstName;
  private String lastName;
  private String address1;
  private String address2;
  private String city;
  private String state;
  private String zip;
  private String phoneNumber;
  private String emailAddress;
  private NamingContext context;

  public CustomerImplementation()
    throws RemoteException
  {
    super();
  }

  public void setContext(NamingContext context)
  {
    this.context = context;
  }

  /**
   * This method binds Customer object
   * to the regisrty customerID as the name
   */
  public void bind(String customerID)
  {
    try {
      java.rmi.Remote stub = PortableRemoteObject.toStub(this);
      NameComponent nc = new NameComponent(customerID, "");
      NameComponent path[] = { nc };
      this.context.rebind(path, (org.omg.CORBA.Object) stub);
    } catch (Exception e) {
      System.out.println("Error in binding the customer :" + e
                           + "customerID :" + customerID);
    }
  }

  public String getFirstName()
  {
    return this.firstName;
  }

  public String getLastName()
  {
    return this.lastName;
  }

  public String getAddress1()
  {
    return this.address1;
  }

  public String getAddress2()
  {
    return this.address2;
  }

  public String getState()
  {
    return this.state;
  }

  public String getPhoneNumber()
  {
    return this.phoneNumber;
  }

  public String getEmailAddress()
  {
    return this.emailAddress;
  }

  public String getZip()
  {
    return this.zip;
  }

  public void setZip(String zip)
  {
    this.zip = zip;
  }

  public String getCity()
    throws RemoteException
  {
    return this.city;
  }

  public void setCity(String city)
  {
    this.city = city;
  }

  public void setFirstName(String firstName)
  {
    this.firstName = firstName;
  }

  public void setLastName(String lastName)
  {
    this.lastName = lastName;
  }

  public void setAddress1(String address1)
  {
    this.address1 = address1;
  }

  public void setAddress2(String address2)
  {
    this.address2 = address2;
  }

  public void setState(String state)
  {
    this.state = state;
  }

  public void setPhoneNumber(String phoneNumber)
  {
    this.phoneNumber = phoneNumber;
  }

  public void setEmailAddress(String emailAddress)
  {
    this.emailAddress = emailAddress;
  }

}

