package ejava.rmi.sampleactivatable;

import java.io.IOException;
import java.util.prefs.Preferences;
import java.util.Properties;
import java.rmi.MarshalledObject;
import java.rmi.activation.ActivationGroupDesc;
import java.rmi.activation.ActivationGroupID;
import java.rmi.activation.ActivationGroup;
import java.rmi.activation.ActivationException;
import java.rmi.activation.ActivationDesc;
import java.rmi.activation.Activatable;
import java.rmi.RMISecurityManager;
import java.rmi.Naming;

public class SampleServerConfigure
{

  public static void main(String[] args)
  {
    Preferences preferences =
      Preferences.userNodeForPackage(ejava.rmi.QueryServer.class);

    System.setSecurityManager(new RMISecurityManager());

    try {
      // Get class name and class directory location
      String serverClassName =preferences.get("SERVER_CLASS_NAME",null);
      String location = preferences.get("LOCATION",null);

      // Initialze data to be send to the activatable object
      MarshalledObject dataToTheObject = null;
      // for our case we will be using same jvm as rmid's
      ActivationGroupDesc.CommandEnvironment cmd = null;
      ActivationGroupID activationID =
        ActivationGroup.getSystem().registerGroup(
                 new ActivationGroupDesc(System.getProperties(), cmd));
      ActivationDesc acdesc 
         = new ActivationDesc(activationID, serverClassName,   
                               location, dataToTheObject);

      // Register the activatable object
      SampleServer server = (SampleServer)Activatable.register(acdesc);

      // Now bind object to registry
      System.out.println("Registered and got the Stub :");
      String serverRegistryName 
          = preferences.get("SERVER_BOUND_NAME",null);
      Naming.rebind(serverRegistryName, server);
      System.out.println("Exported Server:");
      System.exit(0);
    }catch (IOException ioEx) {
      System.out.println("Io ecception :" + ioEx);
    } catch (ActivationException actEx) {
      System.out.println("Activation Exception :" + actEx);
      actEx.printStackTrace();
    }
  }

}

