package ejava.servlets;

// 
import java.io.Serializable;

/**
  * Address class is used in many places, for supplier
  * address information, customer Address information, and
  * delivery address informtion.
  */
public class Address implements Serializable
{
  public static final String ADDRESS_1   = "address_1";
  public static final String ADDRESS_2   = "address_2";
  public static final String CITY       = "city";
  public static final String STATE      = "state";
  public static final String ZIP_CODE   = "zipCode";
  private String address_1;
  private String address_2;
  private String city;
  private String state;
  private String zipCode;

  public Address(String address_1,
    String address_2, String city, String state, String zipCode)
  {
    this.address_1 = address_1;
    this.address_2 = address_2;
    this.city = city;
    this.state = state;
    this.zipCode = zipCode;
  }

  public Address()
  {
    // default constructor
  }

  public Object clone()
  {
    return new Address(address_1, address_2, city, state, zipCode);
  }
  // Getters
  public String getAddress_1()
  {
    return address_1;
  }
  public String getAddress_2()
  {
    return address_2;
  }
  public String getCity()
  {
    return city;
  }
  public String getState()
  {
    return state;
  }
  public String getZipCode()
  {
    return zipCode;
  }
  // Setters
   public void setAddress_1(String newAddress1)
  {
    address_1 = newAddress1;
  }
  public void setAddress_2(String newAddress2)
  {
    address_2 = newAddress2;
  }
  public void setCity(String newCity)
  {
    city = newCity;
  }
  public void setState(String newState)
  {
    state = newState;
  }
  public void setZipCode(String newZipCode)
  {
    zipCode = newZipCode;
  }

  // Convert to a String
  public String toString()
  {
    return " address1 : "+address_1 +" address2: "+address_2+" city: "+city+
      " state : "+state+" zip_code : "+zipCode;
  }

  // Get the Address as a formatted HTML TABLE
  public String getAddressAsHTMLTable(String addressTitle)
  {
    StringBuffer outputString = new StringBuffer();
    outputString.append("<TABLE BORDER=0"+
      " CELLSPACING=0 CELLPADDING=0  BGCOLOR=\"#FFCC66\" >");
    outputString.append("<TR> <TD COLSPAN=\"2\" > <STRONG> "+
      addressTitle+" <STRONG> </TD> </TR>");
    outputString.append(" <TR> <TD> "+ ADDRESS_1 +
      " :  </TD> <TD> " +address_1 +" <TD> </TR> ");
    outputString.append(" <TR> <TD> "+ ADDRESS_2 +
      " :  </TD> <TD> " +address_2 +" <TD> </TR> ");
    outputString.append(" <TR> <TD> "+ CITY +
      " :  </TD> <TD> " +city +" <TD> </TR> ");
    outputString.append(" <TR> <TD> "+ STATE +
      " :  </TD> <TD> " +state +" <TD> </TR> ");
    outputString.append(" <TR> <TD> "+ ZIP_CODE +
      " :  </TD> <TD> " +zipCode +" <TD> </TR> ");
    outputString.append("</TABLE>");

    return outputString.toString();

  }
}

