package ejava.servlets;

// 
import java.io.IOException;
import java.io.PrintWriter;

// 
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
  * This servlet generates the Contact Information page
  */
public class ContactInformationServlet extends HttpServlet
{
   public static final String SERVLET_NAME="/ContactInformationServlet";

/**
  * Each time the Client calls this Servlet, the service method
  * is invoked once.
  */
  public void service (HttpServletRequest servletRequest,
    HttpServletResponse servletResponse)
    throws ServletException, IOException
  {
    // Create initial document type and headers
    PrintWriter printWriter =
      ServletsHelper.createInitialDocumentResponse(servletResponse);
    // Write the body of the page
    writePageBody(printWriter,servletRequest);
    // Close with BODY and HTML closing tags
    ServletsHelper.createClosingDocumentResponse(printWriter);
  }
/**
  * Write Page Body
  */
  private void writePageBody(PrintWriter printWriter,
    HttpServletRequest servletRequest)
  {
    // Write out the top half and the left hand side.
    ServletsHelper.writePageTopArea(  printWriter);
    printWriter.println("<TABLE BORDER=0 COLS=2 WIDTH=\"100%\" >");
    printWriter.println(" <TR> ");
    String serverInfo = ServletsHelper.getServerInfo(servletRequest);
    ServletsHelper.writePageLeftArea(printWriter, serverInfo);
    // Write the center of the page
    writePageCenterArea(printWriter);
    // close the TABLE
    printWriter.println("</TR>");
    printWriter.println("</TABLE> <br>&nbsp;");

  }
/**
  * Write the center of the page with contact information
  */
  private void writePageCenterArea(PrintWriter printWriter)
  {
    printWriter.println("<TD  > "+
        "<UL> " +
        " <FONT SIZE=\"5\" COLOR=\"#000066\"> <P> Contacts </FONT> </P> " +
        " <P> Contact <A HREF=\"mailto:contact@beeshirts.com\"> Contact Personnel </A> " +
        " for any additional information or for ideas how we can help you. </P> "+
        " <BR>Phone : (703) 555-1234  "+
        " <BR>Fax : (703) 555-4321  " +
        " <BR> Email: <A HREF=\"mailto:contact@beeshirts.com\"> contact@beeshirts.com</A> " +
        " <BR> "+
        " Order Problems Report : <A HREF=\"mailto:orders@beeshirts.com\"> orders@beeshirts.com</A> " +
        " <BR> General Problems Report : <A HREF=\"mailto:general@beeshirts.com\"> general@beeshirts.com</A> "+
        " <BR> System Failure Report:    <A HREF=\"mailto:systems@beeshirts.com\"> systems@beeshirts.com</A> "+
        " </UL>   "+
        "</TD>");
  }
}
