package ejava.servlets;

// 
import java.io.Serializable;

/**
  * Encapsulate Customer Inforamtion
  */
public class Customer implements Serializable
{
  public static final String FIRST_NAME ="firstName";
  public static final String LAST_NAME ="lastName";
  public static final String MIDDLE_NAME = "middleName";
  public static final String PHONE = "phone";
  public static final String EMAIL = "email";
  public static final String CUSTOMER_ID = "customerID";
  public static final String PASSWORD = "password";
  public static final String CUSTOMER_OBJECT = "CUSTOMER_OBJECT";
  
  private Address address;
  private String firstName;
  private String lastName;
  private String middleName;
  private String customerID;
  private String phone;
  private String email;
  private String password ;
  private ChargeCard chargeCard;

  public Customer(String firstName, String lastName,
    String middleName, String customerID, Address address,
    String phone,String email, String password, ChargeCard chargeCard )
  {
    this.firstName = firstName;
    this.lastName = lastName;
    this.middleName = middleName;
    this.customerID = customerID;
    this.address = address;
    this.phone = phone;
    this.email = email;
    this.password = password;
    this.chargeCard = chargeCard;
  }
/**
  * Set all info when create (Except customer ID)
  */
  public Customer(String firstName, String lastName,
    String middleName,  Address address,
    String phone,String email, String password)
  {
    this.firstName = firstName;
    this.lastName = lastName;
    this.middleName = middleName;
    this.address = address;
    this.phone = phone;
    this.email = email;
    this.password = password;
  }
  
  public Customer()
  {
    // default constructor
  }

  // Getters
  public String getFirstName()
  {
    return firstName;
  }
  public String getLastName()
  {
    return lastName;
  }
  public String getMiddleName()
  {
    return middleName;
  }
  public String getCustomerID()
  {
    return customerID;
  }
  public String getPhone()
  {
    return phone;
  }
  public String getEmail()
  {
    return email;
  }
  public Address getAddress()
  {
    return address;
  }
  public String getPassword()
  {
    return password;
  }
   public ChargeCard getChargeCard()
  {
    return chargeCard ;
  }
  // Setters
  public void setFirstName(String newFirstName)
  {
     firstName = newFirstName;
  }
  public void setLastName(String newLastName)
  {
     lastName = newLastName;
  }
   public void setMiddleName(String newMiddleName)
  {
     middleName = newMiddleName;
  }
   public void setPhone(String newPhone)
  {
     phone = newPhone;
  }
  public void setEmail(String newEMail)
  {
     email = newEMail;
  }
  public void setAddress(Address newAddress)
  {
    address = newAddress;
  }

  public void setCustomerID(String newCustomerID)
  {
    customerID = newCustomerID;
  }

  public void setPassword(String newPassword)
  {
    password = newPassword;
  }

  public void setChargeCard(ChargeCard newChargeCard)
  {
    chargeCard = newChargeCard;
  }

  // Get the Customer object in String form
  public String toString()
  {
    String returnValue = "";
     returnValue ="first_name : "+ firstName + " last_name : "+lastName +
      " middle_name : " +middleName + " customer_id :"+ customerID +
       address.toString() + " phone :"+phone +
      " eMail : "+ email + " Passoword :" +password ;
    if(chargeCard != null){
       returnValue += chargeCard.toString() ;
    }

    return returnValue;
  }

  public Object clone()
  {
    return new Customer(firstName, lastName, middleName, customerID,
      address, phone, email, password, chargeCard);
  }
  // Get the Customer object in formatted HTML table form
  public String getCustomerAsHTMLTable()
  {
    StringBuffer outputString = new StringBuffer();
    outputString.append("<TABLE BORDER=0"+
      " CELLSPACING=0 CELLPADDING=0  BGCOLOR=\"#FFCC66\" >");
    outputString.append(" <TR> <TD> "+ FIRST_NAME +
      " :  </TD> <TD> " +firstName +" <TD> </TR> ");
    outputString.append(" <TR> <TD> "+ LAST_NAME +
      " :  </TD> <TD> " +lastName +" <TD> </TR> ");
    outputString.append(" <TR> <TD> "+ MIDDLE_NAME +
      " :  </TD> <TD> " +middleName +" <TD> </TR> ");
    outputString.append(" <TR> <TD> "+ PHONE +
      " :  </TD> <TD> " +phone +" <TD> </TR> ");
    outputString.append(" <TR> <TD> "+ EMAIL +
      " :  </TD> <TD> " +email +" <TD> </TR> ");
    if(address != null){
      outputString.append(" <TR> <TD VALIGN=TOP > "+
        address.getAddressAsHTMLTable("ADDRESS :" )+
        " <TD> </TR> ");
    }
    outputString.append("</TABLE>");
    return outputString.toString();

  }

} 
