package ejava.servlets;

// 
import java.io.Serializable;

/**
  * Encapsulates a base item in our object model
  */
public class Item implements Serializable
{
  public static String ITEM_ID = "itemID";
  public static String QUANTITY = "quantity";
  public static String TOTAL_PRICE = "totalPrice";

  private int itemID;
  private int quantity;
  private double totalPrice;

  public Item(int itemID,
    int quantity, double totalPrice)
  {
    this.itemID = itemID;
    this.quantity = quantity;
    this.totalPrice = totalPrice;
  }

  public Item()
  {
    // default Constructor
  }

/**
  * Setters
  */
  public void setItemID(int newItemID)
  {
    itemID = newItemID;
  }
  public void setQuantity(int newQuantity)
  {
    quantity = newQuantity;
  }
  public void setTotalPrice(double newTotalPrice)
  {
    totalPrice = newTotalPrice;
  }
  
/**
  * Getters
  */
  public int getItemID()
  {
    return itemID ;
  }
  public int getQuantity()
  {
    return quantity ;
  }
  public double  getTotalPrice()
  {
    return totalPrice;
  }
  
/**
  * Get the Item as a String
  */
  public String toString()
  {
    return "ItmeID :" +itemID +" Quantity :" +quantity +
      "TotalPrice :" +totalPrice ;
  }

  public Object clone()
  {
    return new Item(itemID, quantity, totalPrice);
  }
/**
  * Get the item as a formatted HTML table
  */
  public String getItemAsHTMLTable()
  {
    StringBuffer outputString = new StringBuffer();
    outputString.append("<TABLE BORDER=0"+
      " CELLSPACING=0 CELLPADDING=0 BGCOLOR=\"#FFCC66\" >");
    outputString.append(" <TR> <TD> "+ ITEM_ID +
      " :  </TD> <TD> " +itemID +" <TD> </TR> ");
    outputString.append(" <TR> <TD> "+ QUANTITY +
      " :  </TD> <TD> " +quantity +" <TD> </TR> ");
    outputString.append(" <TR> <TD> "+ TOTAL_PRICE +
      " :  </TD> <TD> " +totalPrice +" <TD> </TR> ");
    // now Add the TShirt inforamtion to the Results
    outputString.append(" <TR> <TD VALIGN=TOP > ");
    outputString.append(" <TD> </TR> ");
    outputString.append("</TABLE>");

    return outputString.toString();

  }
}
