package ejava.servlets;

import javax.servlet.ServletContextAttributeEvent;
import javax.servlet.ServletContextAttributeListener;

/**
 *  This class implements the ServletRequestAttributeListener
 *  interface.  It simply writes a log message whenever an
 *  attribute is added, changed or removed from a ServletContext.
 */
public class ServletContextAuditor 
                 implements ServletContextAttributeListener
{

    public ServletContextAuditor()
    {
    }

    public void attributeAdded(ServletContextAttributeEvent scab) 
    {
	String message = "Added attribute name=" + scab.getName();
        message += " value=" + scab.getValue() + " to context.";

	scab.getServletContext().log(message);
    }

    public void attributeRemoved(ServletContextAttributeEvent scab) 
    {
	String message = "Removed attribute name=" + scab.getName();
        message += " value=" + scab.getValue() + " from  context.";

	scab.getServletContext().log(message);
    }

    public void attributeReplaced(ServletContextAttributeEvent scab)
    {
	String message = "Replaced attribute name=" + scab.getName();
        message += " value=" + scab.getValue() + " in  context.";

	scab.getServletContext().log(message);
    }
}
