package ejava.servlets;

// 
import java.io.IOException;
import java.io.PrintWriter;

// 
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
  * This servlet generates the Terms and Conditions page
  */
public class TermsAndConditionsServlet extends HttpServlet
{
  public static final String SERVLET_NAME="/TermsAndConditionsServlet";

 public void service(HttpServletRequest servletRequest,
    HttpServletResponse servletResponse)
    throws ServletException, IOException
 {
    // Create initial document type and headers
    PrintWriter printWriter =
      ServletsHelper.createInitialDocumentResponse(servletResponse);
    // Write page body
    writePageBody(printWriter,servletRequest);
    // Close with BODY and HTML closing tags
    ServletsHelper.createClosingDocumentResponse(printWriter);
 }

/**
  * Write Page Body
  */
  private void writePageBody(PrintWriter printWriter,
    HttpServletRequest servletRequest)
  {
    // Write top half of page
    ServletsHelper.writePageTopArea(printWriter);
    // Divide remaining half into two table columns
    printWriter.println("<TABLE BORDER=0 COLS=2 WIDTH=\"100%\" >");
    printWriter.println(" <TR> ");
    String serverInfo = ServletsHelper.getServerInfo(servletRequest);
    // Write left hand side buttons
    ServletsHelper.writePageLeftArea(printWriter, serverInfo);
    // Write center of page
    writePageCenterArea(printWriter);
    // close the TABLE
    printWriter.println("</TR>");
    printWriter.println("</TABLE> <br>&nbsp;");

  }

/**
  * Write the generic terms and conditions information
  */
  private void writePageCenterArea(PrintWriter printWriter)
  {
    printWriter.println("<TD  ALIGN=TOP > "+
        "<UL> " +
        " <TD ALIGN=TOP> "+
        " <UL> "+
        " <LI> <STRONG> Return Policy: </STRONG> All shirts in their original condition can be returned"+
        "  at your return "+
        "  expense and must be returned within <STRONG> 30 Days </STRONG> of purchase. "+
        " <LI> <STRONG> View Order: </STRONG> You can view your orders only if you have a password for your Account."+
        " <LI> <STRONG> Disputes: </STRONG> All and any disputes related to \"BeeShirts.com\" "+
        "           service shall be subject to the jurisdiction of the J2EE Community. " +
        " <LI> <STRONG> Brands, Trade Marks, and Logos: </STRONG> All the Trade marks of the merchandise and software used "+
        "   in this example application are the Trade Marks of the respective companies. "+
        " </UL> </TD>  ");
  }



}
