package ejava.tcpip;

import java.io.*;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.MulticastSocket;
import java.net.InetAddress;
import java.util.Date;
import java.util.*;

/**
 * This example shows how to write a DatagramServer
 */
public class SampleDatagramServer extends Thread {
    private DatagramSocket datagramSocket;
    public int             serverPortNumber = 6666;

    public SampleDatagramServer() throws Exception {
        super();

        datagramSocket = new DatagramSocket(serverPortNumber);
    }

    public void run() {
        while (true) {
            try {
                byte[]         bufferToReceive = new byte[16];

                // read requestFrom Client
                DatagramPacket receivedPacket = 
                    new DatagramPacket(bufferToReceive, 
                                       bufferToReceive.length);

                datagramSocket.receive(receivedPacket);

                String s = new String(receivedPacket.getData());
                byte[] bufferToSend = null;

                if (s.trim().equalsIgnoreCase("ORDERS")) {
                    Order o = new Order(100, new Date().toString(), 
                                        100.00);

                    bufferToSend = o.toString().getBytes();
                } else {
                    bufferToSend = 
                        new String(" Wrong Request send ").getBytes();
                } 

                // send the response to the client at "clientAddress"
                // and "clientPort"
                InetAddress    clientAddress = 
                    receivedPacket.getAddress();
                int            clientPort = receivedPacket.getPort();
                DatagramPacket packetToSend = 
                    new DatagramPacket(bufferToSend, 
                                       bufferToSend.length, 
                                       clientAddress, clientPort);

                datagramSocket.send(packetToSend);
            } catch (IOException e) {
                e.printStackTrace();
            } 
        } 
    } 

    protected void finalize() throws Throwable {
        if (datagramSocket != null) {
            datagramSocket.close();
        } 
    } 

    public static void main(String[] args) throws Exception {
        new SampleDatagramServer().start();
    } 

}

