package ejava.webservices;

/**
 * @author Perrone, Chaganti, and Schwenk
 *
 * J2EE Developer's Handbook
 * 
 * Package: ejava.webservices
 * 
 * Type: ImageReader
 * 
 */

import java.io.*;
import java.awt.image.*;
import javax.imageio.*;
import java.awt.*;

public class ImageReader extends Frame{

    String fileName = "";
    int height = 500;
    int width = 500;
    Image image = null;

    public static void main(String args[]){
        ImageReader ir = new ImageReader();
        ir.render("coupon.jpg");
    }
    
    public ImageReader(){
        super("Image Reader");
        setSize(height,width);
    }

    public ImageReader(InputStream imageStream){
        super("Image Reader");
        setSize(height,width);
        setImage(imageStream);
    }


    public ImageReader(Image anImage){
        super("Image Reader");
        setSize(height,width);
        image = anImage;
    }

    
    public void render(String aFileName, int theHeight, int theWidth){
        height = theHeight;
        width = theWidth;
        
        setSize(height, width);

        render(aFileName);
    }

    public void render(String aFileName){
        fileName = aFileName;

        try{
            File f = new File(fileName);
            image = ImageIO.read(f);
        }
        catch(Exception e){
            e.printStackTrace();
        }

        render();
    }


    public void render(){
        show();
    }

    
    public void paint(Graphics g){
        try{
            g.drawImage(image,0,0,this);
        }
        catch(Exception e){
            e.printStackTrace();
        }
    }
    
    public Image getImage(){
        return image;
    }
    
    public void setImage(InputStream imageStream){
        try{
            image = ImageIO.read(imageStream);
        }
        catch(Exception e){
            e.printStackTrace();
        }
    }
}
