package ejava.webservices.rpc;

/**
 * @author Paul Perrone
 *
 * J2EE Developer's Handbook
 * 
 * Package: ejava.webservices.rpc
 * 
 * Type: Service
 * 
 * Defines a Web services endpoint.
 * 
 */

import java.rmi.Remote;
import java.rmi.RemoteException;

public interface QueryServer extends Remote
{
  public String ping() 
  	      throws RemoteException;          

  public Order findOrder(int orderID)
          throws RemoteException;

  public void lookupCustomers(float value)
          throws RemoteException;

  public Customer getNextCustomer()
          throws RemoteException;

  public void clearCustomers()
          throws RemoteException;

  public void resetCustomers()
          throws RemoteException;

  public int length()
          throws RemoteException;          
}

